/*
 * Copyright (c) 2018-2020 C4
 *
 * This file is part of Curios, a mod made for Minecraft.
 *
 * Curios is free software: you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Curios is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with Curios.  If not, see <https://www.gnu.org/licenses/>.
 */

package top.theillusivec4.curios.common.inventory;

import net.minecraft.class_1277;
import net.minecraft.class_1799;
import net.minecraft.class_2371;
import net.minecraft.class_2487;
import net.minecraft.class_2499;
import top.theillusivec4.curios.api.type.inventory.IDynamicStackHandler;
import top.theillusivec4.curios.mixin.ISimpleInventoryAccessor;

public class DynamicStackHandler extends class_1277 implements IDynamicStackHandler {

  protected class_2371<class_1799> previousStacks;

  public DynamicStackHandler(int size) {
    super(size);
    this.previousStacks = class_2371.method_10213(size, class_1799.field_8037);
  }

  @Override
  public void setPreviousStack(int slot, class_1799 stack) {
    this.previousStacks.set(slot, stack);
  }

  @Override
  public class_1799 getPreviousStack(int slot) {
    return this.previousStacks.get(slot);
  }

  @Override
  public void grow(int amount) {
    ((ISimpleInventoryAccessor) this).setStacks(
        getResizedList(this.method_5439() + amount, ((ISimpleInventoryAccessor) this).getStacks()));
    this.previousStacks = getResizedList(this.previousStacks.size() + amount, this.previousStacks);
    ((ISimpleInventoryAccessor) this).setSize(this.method_5439() + amount);
  }

  @Override
  public void shrink(int amount) {
    ((ISimpleInventoryAccessor) this).setStacks(
        getResizedList(this.method_5439() - amount, ((ISimpleInventoryAccessor) this).getStacks()));
    this.previousStacks = getResizedList(this.previousStacks.size() - amount, this.previousStacks);
    ((ISimpleInventoryAccessor) this).setSize(this.method_5439() - amount);
  }

  @Override
  public class_2487 serializeTag() {
    class_2499 listTag = new class_2499();

    for (int i = 0; i < this.method_5439(); ++i) {
      class_1799 itemStack = this.method_5438(i);
      if (!itemStack.method_7960()) {
        class_2487 compoundTag = new class_2487();
        compoundTag.method_10567("Slot", (byte) i);
        itemStack.method_7953(compoundTag);
        listTag.add(compoundTag);
      }
    }
    class_2487 tag = new class_2487();
    tag.method_10566("Items", listTag);
    tag.method_10569("Size", ((ISimpleInventoryAccessor) this).getStacks().size());
    return tag;
  }

  @Override
  public void deserializeTag(class_2487 tag) {
    int size = tag.method_10573("Size", 3) ? tag.method_10550("Size")
        : ((ISimpleInventoryAccessor) this).getStacks().size();
    ((ISimpleInventoryAccessor) this).setStacks(class_2371.method_10213(size, class_1799.field_8037));
    this.previousStacks = class_2371.method_10213(size, class_1799.field_8037);
    ((ISimpleInventoryAccessor) this).setSize(size);

    if (tag.method_10545("Items")) {
      class_2499 items = tag.method_10554("Items", 10);
      int j;

      for (j = 0; j < this.method_5439(); ++j) {
        this.method_5447(j, class_1799.field_8037);
      }

      for (j = 0; j < items.size(); ++j) {
        class_2487 compoundTag = items.method_10602(j);
        int k = compoundTag.method_10571("Slot") & 255;

        if (k < this.method_5439()) {
          this.method_5447(k, class_1799.method_7915(compoundTag));
        }
      }
    }
  }

  private static class_2371<class_1799> getResizedList(int size,
      class_2371<class_1799> stacks) {
    class_2371<class_1799> newList = class_2371.method_10213(size, class_1799.field_8037);

    for (int i = 0; i < newList.size() && i < stacks.size(); i++) {
      newList.set(i, stacks.get(i));
    }
    return newList;
  }
}
