/*
 * Copyright (c) 2018-2020 C4
 *
 * This file is part of Curios, a mod made for Minecraft.
 *
 * Curios is free software: you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Curios is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with Curios.  If not, see <https://www.gnu.org/licenses/>.
 */

package top.theillusivec4.curios.mixin;

import io.netty.buffer.Unpooled;
import java.util.Collection;
import net.fabricmc.fabric.api.network.ServerSidePacketRegistry;
import net.minecraft.class_2535;
import net.minecraft.class_2540;
import net.minecraft.class_3222;
import net.minecraft.class_3324;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;
import top.theillusivec4.curios.api.CuriosApi;
import top.theillusivec4.curios.api.type.ISlotType;
import top.theillusivec4.curios.common.CuriosNetwork;

@Mixin(class_3324.class)
public class PlayerManagerMixin {

  @Inject(method = "onPlayerConnect", at = @At("TAIL"))
  public void onPlayerConnect(class_2535 connection, class_3222 player,
      CallbackInfo cb) {
    Collection<ISlotType> slotTypes = CuriosApi.getSlotHelper().getSlotTypes();
    class_2540 packetByteBuf = new class_2540(Unpooled.buffer());
    packetByteBuf.writeInt(slotTypes.size());
    slotTypes.forEach(type -> {
      packetByteBuf.method_10814(type.getIdentifier());
      packetByteBuf.method_10814(type.getIcon().toString());
    });
    ServerSidePacketRegistry.INSTANCE.sendToPlayer(player, CuriosNetwork.SET_ICONS, packetByteBuf);
  }
}
